<?php
namespace Teknisa\CMP\Modules\Fornecimento\Modules\EmissaoAutorizacaoFornecimento\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Cmp05200AfsPorFornecedor extends \Zeedhi\Framework\Controller\Report {
    protected $reportService;
    protected $entityManager;
    protected $qr2Strategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $dataSourceManager;
    protected $stNomeRel;
    protected $filialService;

    public function __construct($reportService, $entityManager, $qr2Strategy, $newCode, $environment, $connection, $dataSourceManager, $filialService) {
        $this->reportService     = $reportService;
        $this->entityManager     = $entityManager;
        $this->qr2Strategy       = $qr2Strategy;
        $this->newCode           = $newCode;
        $this->environment       = $environment;
        $this->connection        = $connection;
        $this->dataSourceManager = $dataSourceManager;
        $this->filialService     = $filialService;
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $cdOperador = $this->environment->getCdOperador();
        
        if($row["L_FILIAL"] == "T") {
            $newFilial = $this->filialService->retornaListaDeFiliais($cdOperador);
            if(is_array($newFilial)) {
                    $str = "_";
                    foreach($newFilial as $filial) {
                        foreach($filial as $cdfilial) {
                            $str .= $cdfilial . '_';
                        }
                    }
                    $newFilial = $str;
                    $row["L_FILIAL"] = $newFilial;
                }
        }
        
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] =
            array(
                'strategy' => $row['STRATEGY'],
                'parameterMapping' =>
                    array(
                        'L_FILIAL'          => 'L_CDFILIAL',
                        'L_FORNECEDOR'      => 'L_CDFORNECED',
                        'CDOPERADOR'        => 'L_CDOPERADOR',
                        'CDIMPOSTO'         => 'L_CDIMPOSTO',
                        'L_REGIAO'          => 'L_CDREGIAO',
                        'DTAFINI'           => 'P_DTAFINI',
                        'DTAFFIN'           => 'P_DTAFFIN',
                        'RADIODATA'         => 'P_IDDATASEL',
                        'FILIALLOGADA1'     => 'P_CODFILIPROC',
                        'FILIALLOGADA2'     => 'P_CDFILIPROC',
                        'RADIOIMPRIME'      => 'P_IDAFIMP',
                        'IMPRIMEOBS'        => 'P_IMPRIMEOBS',
                        'IMPRIMEOBSPROD'    => 'P_IMPRIMEOBSPROD',
                        'MODO'              => 'P_MODO',
                        'NMMENSCMP'         => 'P_NMMENSCMP',
                        'CDMENSCMP'         => 'P_CDMENSCMP'
                    ),
            );
    }
}
