<?php
namespace Teknisa\CMP\Modules\Fornecimento\Modules\EmissaoAutorizacaoFornecimento\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Cmp05500AfGeralPorAfsFornecedor extends \Zeedhi\Framework\Controller\Report 
{

    protected $entityManager;
    protected $qr2Strategy;

    public function __construct($reportService, $entityManager, $qr2Strategy) 
    {
        
        $this->entityManager       = $entityManager;
        $this->qr2Strategy         = $qr2Strategy;
        $this->reportService       = $reportService;

    }

    protected $reportMapping = array(
        'Cmp05500' =>
            array(
                'strategy' => 'QR2',
                'parameterMapping' =>
                    array(
                        'CDPRODUTOINI'      => 'P_CDPRODINI',
                        'CDPRODUTOFIM'      => 'P_CDPRODFIM',
                        'SEPFORNECEDOR'     => 'P_PAGINA',
                        'DATAINI'           => 'P_DATAINI',
                        'DATAFIN'           => 'P_DATAFIM',
                        'L_FILIAL'          => 'L_FILIAL',
                        'L_CDGRUPFILI'      => 'L_CDGRUPFILI',
                        'L_FORNECEDOR'      => 'L_CDFORNECEDOR',
                        'CDPRODINICOC'      => 'P_CDPRODINICOC',
                        'CDPRODFINAL'       => 'P_CDPRODFIMCOC',
                        'MODO'              => 'P_MODO'
                    ),
            ),
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $tamanho = 10;
        $completaCom = 'z';
        $row['CDPRODFINAL'] = $row['CDPRODUTOFIM'];
        $row['CDPRODINICOC'] = $row['CDPRODUTOINI'];
        
        $row['CDPRODFINAL'] = str_pad($row['CDPRODFINAL'], $tamanho, $completaCom, STR_PAD_RIGHT);
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
    }

}