<?php
namespace Teknisa\CMP\Modules\Solicitacao\Modules\Relatorios\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Cmp04800FormularioDeLancamentoDeSolicitacoesDeCompraController extends \Zeedhi\Framework\Controller\Report
{
    protected $entityManager;
    protected $qr2Strategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $stNomeRel;

    public function __construct($reportService, $entityManager, $qr2Strategy, $newCode, $environment, $connection)
    {
        $this->entityManager       = $entityManager;
        $this->qr2Strategy         = $qr2Strategy;
        $this->reportService       = $reportService;
        $this->newCode             = $newCode;
        $this->environment         = $environment;
        $this->connection          = $connection;
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {
        $NRLISTA = $this->newCode->getCodeByTableName('NRLISTA', $this->environment->getNrorgTrab(), 1, 10, false);
        
        $row = $request->getRow();
        
        $this ->insertLista($NRLISTA);
        $row['CDPRODINI1'] = $row['CDPRODINI'];
        
        $this->qr2Strategy->setQr2Type(strtolower($row['QR2TYPE']));
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] =
            array (
                'strategy' => $row['STRATEGY'],
                'parameterMapping' =>
                    array (
                        "CDFILIAL"      => "L_CDFILIAL",
                        "CDPRODINI"     => "P_CDPRODINI",
                        "CDPRODFIN"     => "P_CDPRODFIN",
                        "CDOPERADOR"    => "L_CDOPERADOR",
                        "imprimeProd"   => "P_IMPMED",
                        "imprimeLinhas" => "P_LINBR",
                        "CDPRODINI1"    => "P_CDPRODINI_DIG",
                        "CDPRODFIN1"    => "P_CDPRODFIN_DIG"
                        
                    ),
            );
    }
    
    public function insertLista($nrlista)
    {
    	$params = array(
    		"NRLISTA" => $nrlista,
    		"CDLISTA" => $this->environment->getCdOperador()
    	);
    	
    	$sql = "INSERT INTO LISTA (NRLISTA, CDLISTA) VALUES (:NRLISTA, :CDLISTA)";
    	$query = $this->connection->prepare($sql);
    	$query->execute($params);
    }
}
